#! /usr/bin/perl

use strict;
use warnings;

# Keep your variable declarations/definitions together, 
# even if they are going to be used later on in the script.
# Always define the variables, even if you will change the value later.
#
my $var_number	= 0;
my $var_string	= "";

my $num1		= 0;
my $num2		= 0;
my $num3		= 0;
my $str1		= "";
my $str2		= "";
my $str3		= "";


### Step 1
### Numbers
###
print "Step 1 - numbers\n";
print "\n";

# Note: the character \ is an escape character - below it allows 
# the $ character to be considered a part of the string, not 
# a special character (i.e., here the first character of a variable 
# name).

$var_number	= 0;
print "\$var_number = 0    (Integer):           $var_number\n";

$var_number	= 5;
print "\$var_number = 5    (Integer):           $var_number\n";

$var_number	= -5;
print "\$var_number = -5   (Integer):           $var_number\n";

$var_number		= 1.1;
print "\$var_number = 1.1  (Floating point):    $var_number\n";

$var_number	= 1E-2;
print "\$var_number = 1E-2 (Scientific format): $var_number\n";

# Ouch, careful!
#
$var_number	= 010;
print "\$var_number = 010  (Octal format):      $var_number\n";

print "\n";

<STDIN>;


### Step 2
### Strings 
###
print "Step 2 - strings\n";
print "\n";

# It is OK - but is it a good idea?
#
$var_number = "five";
print "\$var_number = \"five\": $var_number\n";

# Use a different variable name instead:
#
$var_string	= "five";
print "\$var_string = \"five\": $var_string\n";

$var_string	= "5";
print "\$var_string = \"5\": $var_string\n";

print "\n";

<STDIN>;


### Step 3
### Operators
###
print "Step 3 - operators\n";
print "\n";

$num1	= 5;
$num2	= 2;
print "\$num1 = $num1\n";
print "\$num2 = $num2\n";
print "\n";

# We've seen the "assign" operator, i.e. "=", already.

$num3	= $num1 + $num2;
print "Addition: $num3\n";

$num3	= $num1 - $num2;
print "Subtraction: $num3\n";

$num3	= $num1 * $num2;
print "Multiplication: $num3\n";

$num3	= $num1 / $num2;
print "Division: $num3\n";

$num3	= $num1 ** $num2;
print "Exponent: $num3\n";

$num3	= $num1 ** (1/$num2);
print "Root: $num3\n";

$num3	= sqrt($num1);
print "Square root: $num3\n";

$num3	= $num1 % $num2;
print "Modulus: $num3\n";

$num3	= $num1;
$num3	+= $num2;
print "Add and assign: $num3\n";

$num3	= $num1;
$num3	-= $num2;
print "Subtract and assign: $num3\n";

# Similarly: *=, /=, %=, **=

$num1++;
print "Auto Increment \$num1: $num1\n";

$num1--;
print "Auto Decrement \$num1: $num1\n";

print "\n";

<STDIN>;


### Step 4
### Utilize parentheses - they can be nested!
###
print "Step 4 - parentheses\n";
print "\n";

$num3	= $num2 + $num2 * $num1;
print "No parentheses:   $num3\n";
$num3	= ($num2 + $num2) * $num1;
print "With parentheses: $num3\n";

print "\n";

<STDIN>;


### Step 5
### Operations on strings
###
print "Step 5 - operations on strings\n";
print "\n";

$str1	= "abc";
$str2	= "def";
print "\$str1: $str1\n";
print "\$str2: $str2\n";
print "\n";

$str3	= $str1.$str2;
print "Concatenate:            $str3\n";

$str3	= $str1." ".$str2;
print "Separate with a space:  $str3\n";

$str3	= $str1."\t".$str2;
print "Separate with a tab:    $str3\n";

$str3	= $str1."\n".$str2;
print "Separate with new line: $str3\n";

$str3	= $str1;
$str3	.= $str2;
print "Append and assign:      $str3\n";

# Ouch, careful!
#
$str3	= $str1."\r".$str2;
print "Separate with carriage return: $str3\n";
print "\n";

# A couple handy string functions:
# - length - returns number of characters in a string
# - substr - returns a substring of a string
#
print "The length of \$str1: ";
print length($str1);
print "\n";
print "The second and third character of \$str1: ";
print substr($str1, 1, 2);
print "\n";

print "\n";

<STDIN>;


### Step 6
### Perl will do some conversions for you...
###
###
print "Step 6 - conversions\n";
print "\n";

$str1	= "7";
$str2	= "1";
$num1	= 7;
$num2	= 1;
print "\$str1: $str1\n";
print "\$str2: $str2\n";
print "\$num1: $num1\n";
print "\$num2: $num2\n";
print "\n";

$num3	= $str1 + $str2;
print "Addition:      $num3\n";

$str3	= $num1.$num2;
print "Concatenation: $str3\n";

print "\n";
print "Exiting. Please, press enter.\n";
<STDIN>;
exit(0);
