#! /usr/bin/perl

use strict;
use warnings;


my @array1	= ();
my %hash1	= ();

my $key	= "";
my $val	= "";

$array1[0]	= "b";
$array1[1]	= "a";
$array1[2]	= "f";
$array1[3]	= "e";
$array1[4]	= "c";
$array1[5]	= "d";

$hash1{"kb"}	= "vj";
$hash1{"ka"}	= "vi";
$hash1{"kd"}	= "vh";
$hash1{"kc"}	= "vg";
$hash1{"kf"}	= "vk";
$hash1{"ke"}	= "vl";


### Step 1
### Sorting arrays
###
print "Step 1 - sorting arrays\n";
print "\n";

# 1a) Unsorted
#
print "Unsorted:\n";

foreach $val (@array1)
{
	print $val."\n";
}

print "\n";

# 1b) Sorted ascending
#
print "Sorted ascending:\n";

foreach $val (sort @array1)
{
	print $val."\n";
}

print "\n";

# 1c) Sorted descending
#
print "Sorted descending:\n";

foreach $val (sort {$b cmp $a} @array1)
{
	print $val."\n";
}

# If you want to be explicit about sorting ascending, use "$a" and "$b" 
# variables in the reverse order in the sort command above.

print "\n";
<STDIN>;



### Step 2
### Sorting hashes
###
print "Step 2 - sorting hashes\n";
print "\n";

# 2a) Unsorted
#
print "Unsorted:\n";

foreach $key (keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

print "\n";

# 2b) Sorted by key ascending
#
print "Sorted by key ascending:\n";

foreach $key (sort keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

print "\n";

# 2c) Sorted by key descending
#
print "Sorted by key descending:\n";

foreach $key (sort {$b cmp $a} keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

print "\n";

# We can sort the hash by values analogously but there is a problem with 
# the keys:

# 2d) Sorted values ascending
#
print "Sorted values ascending:\n";

foreach $val (sort values %hash1)
{
	print $val."\n";
}

print "\n";

# 2e) Sorted values descending
#
print "sorted values descending:\n";

foreach $val (sort {$b cmp $a} values %hash1)
{
	print $val."\n";
}

print "\n";

# 2f) Sorted keys by value ascending
#
print "Sorted keys by value ascending:\n";

foreach $key (sort {$hash1{$a} cmp $hash1{$b}} keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

print "\n";

# 2g) Sorted keys by value descending
#
print "Sorted keys by value descending:\n";

foreach $key (sort {$hash1{$b} cmp $hash1{$a}} keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

print "\n";


# If the hash contains numbers, the "cmp" operator needs to be replaced 
# with "<=>", otherwise the numbers will not be sorted numerically.
# The "<=>" operator must be used explicitly also when sorting ascending.

# See this "how-to" for details:
# https://perlmaven.com/how-to-sort-a-hash-in-perl

print "\n";
print "Exiting. Please, press enter.\n";
<STDIN>;
exit(0);
