#! /usr/bin/perl

use strict;
use warnings;

my $line			= "";
my $line_out		= "";
my $in_file_name	= "input01.txt";
my $out_file_name	= "output01.txt";

# Open a file for reading, writing, or appending, using the symbols:
# <  - read
# >  - write
# >> - append
#
### Be extremely careful when opening files!
### Once a file has been opened for writing, all the content of the file 
### will be deleted.
### Always make backup copies of important data files.

### Step 1
###
print "Step 1\n";
print "\n";

open FILE_IN, "<", $in_file_name or die $!;

# Read the file and print the content to the screen:
#
while ($line = <FILE_IN>)
{
	print $line;
}
# Always remember to close the files as soon as you don't need them!
#
close FILE_IN;

print "\n";
<STDIN>;



### Step 2
###
print "Step 2\n";
print "\n";

open FILE_IN, "<", $in_file_name or die $!;
open FILE_OUT, ">", $out_file_name or die $!;

# Reopening the input file brings us to the beginning of the file.
# Read the file and print only John's name and phone number but
# substitute spaces with hyphens and convert the last four digits to "xxxx":
#
while ($line = <FILE_IN>)
{
	# In the below "if" command, we cannot do a simple:
	# $line	=~ /Jonh/
	# because the string "John" appears also above the data table.
	#
	if ($line =~ /^\d+\tJohn/)
	{
		chomp($line);
		$line		=~ /^\d+\t(\w+)\t[^\t]+\t(\d{3}\s\d{3}\s)/;
		$line_out	= $1."\t".$2."xxxx";
		$line_out	=~ s/(\d+)\s(\d+)\s(x{4})$/$1\-$2\-$3/;
		print FILE_OUT $line_out."\n";
		print "Output file saved.\n";
		
		# Since we found the entry for John, and if we are sure there are no
		# more records for this name (or we are not interested in those),
		# we could use the command:
		# last;
		# which would allow us to leave the loop. In case of a big 
		# dataset, this could save much time.
		# In general, however, alternative ways of controling program 
		# flow (e.g., if...else and boolean variables)
		# should be used rather than commands like "last".
	}
}
close FILE_OUT;
close FILE_IN;


print "\n";
print "Exiting. Please, press enter.\n";
<STDIN>;
exit(0);
