#! /usr/bin/perl

use strict;
use warnings;

my @array1	= ();
my @array2	= ();
my %hash1	= ();
my %hash2	= ();
my $var1	= "";
my $var2	= "";

### Step 1
### Arrays
###
print "Step 1 - arrays\n";
print "\n";

# Assign values
#
@array1	= ("abc", "def", "ghi");
$array2[0]	= "jkl";
$array2[1]	= "mno";
$array2[2]	= "pqr";

print "\@array1: @array1\n";
print "\@array2: @array2\n";
print "\$array1[1]: $array1[1]\n";
print "\$array2[0]: $array2[0]\n";
print "\@array1, scalar context: ".@array1."\n";
print "\@array2, scalar context: ".@array2."\n";
print "\n";

<STDIN>;


### Step 2
### push, pop, unshift, shift
###
print "Step 2 - push, pop, unshift, shift\n";
print "\n";

$var1	= "ooo";
print "\$var1: $var1\n";
print "\$var2: $var2\n";
print "\@array1: @array1\n";

push @array1, $var1;
print "push (\@array1): @array1\n";
$var2	= pop @array1;
print "pop (\@array1):  @array1\n";
print "    (\$var2):    $var2\n";

$var2	= "";
print "\$var2: $var2\n";
unshift @array1, $var1;
print "unshift (\@array1): @array1\n";
$var2	= shift @array1;
print "shift (\@array1):   @array1\n";
print "      (\$var2):     $var2\n";
print "\n";

<STDIN>;


### Step 3
### join and split
###
print "Step 3 - join and split\n";
print "\n";

@array1	= ();
$var2	= "";
print "\@array1: @array1\n";
print "\@array1, scalar context: ".@array1."\n";
print "\$var2: ".$var2."\n";

$var1	= "abc def ghi";
print "\$var1: $var1\n";
@array1	= split (" ", $var1);
print "\@array1: @array1\n";
print "\@array1, scalar context: ".@array1."\n";
$var2	= join ("_", @array1);
print $var2."\n";
print "\n";

<STDIN>;


### Step 4
### Hashes (pairs: key-value)
###
print "Step 4 - hashes\n";
print "\n";

%hash1	= ("k1", "v1", "k2", "v2");
print $hash1{"k1"}."\n";
%hash2	= (k3 => "v3", k4 => "v4");
print $hash2{"k3"}."\n";

print "\n";

<STDIN>; 


### Step 5
### Delete all content of a hash
###
print "Step 5 - delete all content of a hash\n";
print "\n";

%hash1	= ();
print "\%hash1 deleted\n";
print $hash1{"k1"}."\n";
$hash1{"k5"}	= "v5";
$hash1{"k6"}	= "v6";
print "added new records to \%hash1:\n";
print $hash1{"k5"}."\n";
print $hash1{"k6"}."\n";
print "\n";

<STDIN>; 


### Step 6
### Remove a single record from a hash:
###
print "Step 6 - remove a single record from a hash\n";
print "\n";

delete $hash1{"k5"};
print "deleted the record from \%hash1 where key = \"k5\"\n";
print $hash1{"k5"}."\n";
print $hash1{"k6"}."\n";


print "\n";
print "Exiting. Please, press enter.\n";
<STDIN>;
exit(0);
