#! /usr/bin/perl

use strict;
use warnings;


my $i	= 0;
my $N	= 5;
my $N1	= $N - 1;

my @array1	= ("a", "b", "c");
my %hash1	= ("k1", "v1", "k2", "v2", "k3", "v3");

my $key	= "";
my $val	= "";


### Step 1
### "for" loop
###
print "Step 1 - \"for\" loop\n";
print "\n";

print "\"for\" loop #1:\n";

for ($i	= 0; $i < $N; $i = $i + 1)
{
	print $i."\t";
}

# Please, note the indentation in the above block. It has no effect upon 
# the code but it makes the code more readable.
# The placement of the curly brackets depends on your preference as long 
# as the pair encompasses a given block of code.

print "\n";
print "current value of \$i: ".$i."\n";
print "\n";

print "\"for\" loop #2:\n";

for (my $i	= 0; $i < $N1; $i = $i + 1)
{
	print $i."\t";
}

# You could use the term "$N - 1" as the evaluation criterion instead of the 
# variable "$N1". This would work but it is not a good idea because 
# the program would need to repeat the same operation
# (to calculate the value of $N - 1) during every iteration of the loop.

print "\n";
print "current value of \$i: ".$i."\n";
print "\n";

# The keyword "my" limits the scope of the variable $i to the loop.
# If omitted, it would change the value of $i defined above in the main part 
# of the program. Think of it as of having a second, "independent", variable 
# $i inside of the loop.

<STDIN>;


### Step 2
### "foreach" loop, array
###
print "Step 2 - \"foreach\" loop, array\n";
print "\n";

foreach $val (@array1)
{
	print $val."\n";
}

print "\n";
<STDIN>;


### Step 3
### "foreach" loop, hash
###
print "Step 3 - \"foreach\" loop, hash\n";
print "\n";

foreach $key (keys %hash1)
{
	$val	= $hash1{$key};
	print $key."\t".$val."\n";
}

# Note that the order of the key-value pairs printed on the screen may not 
# be the same as entered during the hash definition step above.

print "\n";
<STDIN>;


$i	= 0;

### Step 4
### "while" loop
###
print "Step 4 - \"while\" loop\n";
print "\n";

while ($i < $N)
{
	print $i;
	print "\t";
	$i++;
}
print "\n";

print "\n";
<STDIN>;


$i	= 0;

### Step 5
### "do...until" loop
###
print "Step 5 - \"do...until\" loop\n";
print "\n";

do
{
	print $i;
	print "\t";
	$i++;
}
until ($i >= $N);
print "\n";

print "\n";
<STDIN>;


$i	= 0;

### Step 6
### "do...while" loop
###
print "Step 6 - \"do...while\" loop\n";
print "\n";

do
{
	print $i;
	print "\t";
	$i++;
}
while ($i < $N);
print "\n";

print "\n";
<STDIN>;


$i	= 0;

### Step 7
### "while" loop terminated using last
###
print "Step 7 - \"while\" loop terminated using last\n";
print "\n";

while ($i < $N)
{
	if ($i == $N1)
	{
		last;
		# In general, alternative ways of controlling the program flow
		# should be used (e.g., if...else and boolean variables)
		# rather than commands like "last".
	}
	
	print $i;
	print "\t";
	$i++;
}
print "\n";
print "current value of \$i: ".$i."\n";
print "\n";


print "\n";
print "Exiting. Please, press enter.\n";
<STDIN>;
exit(0);
